unit Deklar;
interface

uses Graph;

const PocHracov   = 7;
      MaxDl       = 4000;
      ZacCas      = 10000;
      CasNa1Tah   = 10;
      ZacJedla    = 4000;
      ZacX        =  8;
      ZacY        = 40;

      Nic     =  0;
      Seda    =  7;
      Jedlo   =  8;
      Hranica =  9;
      Biela   = 15;

      Sirka   = 300;
      Vyska   = 150;

type
  TSmer  = 0..3;
  PFront = ^TFront;
  TFront = object
             Data: array[0..MaxDl-1] of TSmer;
             Zac, Kon: integer;
             procedure Init;
             procedure FGet(var Co: TSmer);
             procedure FPut(Co: TSmer);
             function FTop: TSmer;
           end;

  THrac = record
            Zivy     : boolean;
            Dlzka    : integer;
            PoslTah  : TSmer;
            Cas      : longint;
            x,y,cx,cy: integer;
            Chvost   : PFront;
          end;

  HraciaPlocha = array[0..Sirka+1,0..Vyska+1] of byte;
  PHraciaPlocha = ^HraciaPlocha;

const
  PosX: array[TSmer] of integer = (1,0,-1,0);
  PosY: array[TSmer] of integer = (0,-1,0,1);

type
  THraci   = array[1..PocHracov] of THrac;
  InitProc = procedure (Kolkaty: integer);
  TahProc  = procedure (var Hraci: THraci; var MojTah: TSmer);

var GetP: PHraciaPlocha;

implementation

procedure TFront.Init;
var i: integer;
begin
  Zac:=0;
  Kon:=0;
  for i:=0 to MaxDl-1 do Data[i]:=0
end;

procedure TFront.FGet(var Co: TSmer);
begin
  Co:=Data[Kon];
  Kon:=(Kon+1) mod MaxDl
end;

procedure TFront.FPut(Co: TSmer);
begin
  Data[Zac]:=Co;
  Zac:=(Zac+1) mod MaxDl
end;

function TFront.FTop:TSmer;
begin
  FTop:=Data[Kon]
end;

end.